//-------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//-------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSandyBrown
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property strict

//
//
//
//
//

enum displayLike
{
   dis_lines, // Display as lines
   dis_dots   // Display as dots
};

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT; // Time frame to use
extern int                Length          = 14;             // Nonlag ma calculation length
extern ENUM_APPLIED_PRICE Price           = PRICE_CLOSE;    // Price to use
extern bool               alertsOn        = true;           // Turn alert on?
extern bool               alertsOnCurrent = true;           // Alerts on current (still opened) bar?
extern bool               alertsMessage   = true;           // Alerts should show pop-up message?
extern bool               alertsSound     = false;          // Alerts should play alert sound?
extern bool               alertsEmail     = false;          // Alerts shoyuld send an email?
extern displayLike        DisplayType     = dis_lines;      // What should the display be like?
extern bool               Interpolate     = true;           // Interpolate in multi time frame mode?

//
//
//
//
//

double NonLagMaBuffer[];
double NonLagMaBufferUa[];
double NonLagMaBufferUb[];
double trend[];
double alphas[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,NonLagMaBuffer);
   SetIndexBuffer(1,NonLagMaBufferUa);
   SetIndexBuffer(2,NonLagMaBufferUb);
   SetIndexBuffer(3,trend);
      if (DisplayType==dis_dots)
      {
         SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
         SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
         SetIndexStyle(2,DRAW_NONE);
      }
      else for (int i=0; i<3; i++) SetIndexStyle(i,DRAW_LINE);         
         
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" non lag MA ("+(string)Length+")");
   return(0);  
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { NonLagMaBuffer[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      if (trend[limit]==-1 && DisplayType==dis_lines) CleanPoint(limit,NonLagMaBufferUa,NonLagMaBufferUb);
      
      //
      //
      //
      //
      //
      
      for (int i=limit; i>=0; i--)
      {
          NonLagMaBuffer[i]   = iNoLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,alphas,0,i);
          NonLagMaBufferUa[i] = EMPTY_VALUE;
          NonLagMaBufferUb[i] = EMPTY_VALUE;
          if (i<Bars-1)
          {
            trend[i] = trend[i+1];
               if (NonLagMaBuffer[i]>NonLagMaBuffer[i+1]) trend[i]= 1;
               if (NonLagMaBuffer[i]<NonLagMaBuffer[i+1]) trend[i]=-1;
               if (trend[i]==-1)
                  if (DisplayType==dis_lines) 
                        PlotPoint(i,NonLagMaBufferUa,NonLagMaBufferUb,NonLagMaBuffer);
                  else  NonLagMaBufferUa[i] = NonLagMaBuffer[i];
          }               
      }            
      manageAlerts();
   	return(0);	
   }	  

   //
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (trend[limit]==-1 && DisplayType==dis_lines) CleanPoint(limit,NonLagMaBufferUa,NonLagMaBufferUb);
   for (int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         NonLagMaBuffer[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,0,y);
         NonLagMaBufferUa[i] = EMPTY_VALUE;
         NonLagMaBufferUb[i] = EMPTY_VALUE;
         trend[i]            = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,3,y);

         //
         //
         //
         //
         //
      
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         //
         //
         //
         //
         //

            int n,k; datetime time = iTime(NULL,TimeFrame,y);
               for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; i+n<Bars && i+k<Bars && k<n; k++)
                  NonLagMaBuffer[i+k] = NonLagMaBuffer[i] + (NonLagMaBuffer[i+n] - NonLagMaBuffer[i])*k/n;
   }
   for (int i=limit;i>=0;i--)
   {
               if (trend[i]==-1)
                  if (DisplayType==dis_lines) 
                        PlotPoint(i,NonLagMaBufferUa,NonLagMaBufferUb,NonLagMaBuffer);
                  else  NonLagMaBufferUa[i] = NonLagMaBuffer[i];
   }
   return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double values[][3];
double prices[][1];

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double price, int length, double &alphasArray[], int forValue, int i)
{
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
            int r = Bars-i-1;  prices[r][forValue]=price;
   if (length<3 || r<3) return(prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alphasArray,(int)values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            double t    = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0);  if (k<=Phase-1) t = 1.0 * k/(Phase-1);
            double beta = MathCos(Pi*t);
            double g    = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alphasArray[k]             = g * beta;
            values[forValue][_weight] += alphasArray[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = (int)values[forValue][_len];
      double sum = 0;
           for (int k=0; r-k>=0 && k<len-1; k++) sum += alphasArray[k]*prices[r-k][forValue];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(TimeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," NonLagMA changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"NonLagMA "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}